#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <frame.h>

static u_int lowpc, highpc;

#define entrypc(pc)	(pc >= lowpc && pc <= highpc)
#define getpc(fp)	(fp->fr_savpc)

struct frame *
getfp ()
{
	asm ("movl 12(fp), r0");
}

void
bt (FILE *filep)
{
	struct frame *fp = getfp ();
	u_int pc = getpc (fp);

	while (!entrypc (pc)) {
		fprintf (filep, "%d:", pc);
		fp = (struct frame *) fp->fr_savfp;
		pc = getpc (fp);
	}
}

int
btinit ()
{
	char *entry = getenv ("MPRPC");

	if (!entry || !strchr (entry, ':'))
		return -1;

	lowpc = atoi (entry);
	highpc = atoi (1 + strchr (entry, ':'));

	return 0;
}
