#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#undef ulong
#define ulong unsigned long

static ulong lowpc, highpc;

/*
 * Number of words between saved pc and saved fp.
 * All stack frames seen by bt() must conform to
 * the same value of SLOP.
 */
#ifndef SLOP
#define SLOP 0
#endif

extern int etext ();

#define entrypc(pc)	((pc >= lowpc && pc <= highpc) || pc >= (ulong) &etext)
#define getfp(ap)	(ap-2-SLOP)
#define getpc(fp)	(fp[1+SLOP])

void
bt (FILE *filep)
{
	ulong pc, *fp = getfp ((ulong *) &filep);

	while (fp && *fp && (pc = getpc (fp)) && !entrypc (pc)) {
		fprintf (filep, "%ld:", pc);
		fp = (ulong *) *fp;
	}
}

int
btinit ()
{
	char *entry = getenv ("MPRPC");

	if (*((char *) btinit + SLOP) != 0x55)	/* 0x55 == pushl %ebp */
		return -1;

	if (!entry || !strchr (entry, ':'))
		return -2;

	lowpc = atoi (entry);
	highpc = atoi (1 + strchr (entry, ':'));

	return 0;
}
